Drupal.filterFormatLoader = function() {
  // prepare the new input formats scheme
  $('.filter-formats .form-item input[@type=radio][@checked]').each( function() {
    var form_item = $(this).parents('.filter-formats').prevAll(":first");
    var textarea = $(form_item).find('textarea')[0];

    // change the input format HTML
    var selected = $(this).parent().text();
    var legend = $(this).parents('.filter-formats').children('legend');
    var fieldset = $(this).parents('.filter-formats');
    var img = Drupal.settings.wymeditor_path;
    $(textarea).parent().append('<div class="filter-formats"><a class="link-open" href="#"><img src="'+ img +'/filter-icon.jpg" alt="" /><span>'+ $(legend).text() +'</span></a><span class="active">'+ selected +'</span></div><div class="filter-formats-box"></div>');
    $(legend).remove();
    $(textarea).parent().find('.filter-formats-box').append($(fieldset).children());
    $(textarea).parent().find('.filter-formats-box').hide();
    $(fieldset).remove();

    // initialize the WYMeditor if it is active
    var key = Drupal.settings.wymeditor_key;
    if ($(this).attr('value') == key) {
      $(textarea).wymeditor($.wymeditor_config);
      $(textarea).fadeOut();
      $(form_item).find('.grippie').fadeOut();
    } else {
      $(form_item).find('.filter-formats').css('margin-right', $(form_item).find('.grippie').css('margin-right'));
    }
  });

  // function to show/hide the new input formats box
  $('.filter-formats .link-open').click( function() {
    $(this).parents('span').find('.link-open').toggleClass('open');
    $(this).parents('span').find('.filter-formats-box').slideToggle('slow');
    return false;
  });

  // function to allow the change of the active editor
  $('.filter-formats-box .form-item input[@type=radio]').change( function() {
    var textarea = $(this).parents('.filter-formats-box').siblings('textarea');
    var form_item = $(this).parents('.form-item')[1];

    var selected = $(this).parent().text();
    $(this).parents('span').find('.active').html(selected);

    var key = Drupal.settings.wymeditor_key;
    if ($(this).attr('value') == key) {
      $(textarea).fadeOut();
      $(form_item).find('.grippie').fadeOut();
      $(form_item).find('.filter-formats').css('margin-right', '0');
      $(textarea).wymeditor($.wymeditor_config);
    } else {
      $(textarea).fadeIn();
      $(form_item).find('.grippie').fadeIn();
      $(form_item).find('.filter-formats').css('margin-right', $(form_item).find('.grippie').css('margin-right'));
      $(form_item).find('.wym_box').remove();
    }
    $(this).parents('.filter-formats-box').slideUp('slow');
  });
};

if (Drupal.jsEnabled) {
  $(document).ready(Drupal.filterFormatLoader);
};
